質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.91%

【Rails】Permission denied @ dir_s_mkdir - のエラーに困っております。

解決済

回答 3

投稿

  • 評価
  • クリップ 1
  • VIEW 189

akinroi

score 0

前提・実現したいこと

初めて質問させて頂きます。
プログラミングスクールで3ヶ月ほど勉強した者です。
自分のサービスを作ろうとして、rails newをして、rails sをすると、エラーが発生します。

ひとまず、今発生しているエラーの解決方法が知りたいです。
よろしくお願いします。

発生している問題・エラーメッセージ

【1つ目】 ”rails s”の後

Webpacker configuration file not found /Users/username/projects/ファイル名/config/webpacker.yml. Please run rails webpacker:install Error: No such file or directory @ rb_sysopen - /Users/username/projects/ファイル名/config/webpacker.yml (RuntimeError)


このエラーが出たので、以下を打ち込みました。

rails webpacker:install


そうすると、次のエラーが発生します。

【2つ目】 ”rails webpacker:install”の後

Yarn not installed. Please download and install Yarn from https://yarnpkg.com/lang/en/docs/install/


このエラーが出たので、以下を打ち込みました。

brew install yarn


そうすると、次のエラーが発生します。

【3つ目】 "brew install yarn"の後

Error: Permission denied @ dir_s_mkdir - /private/tmp/homebrew20200722-28292-9dgqhj


権限の問題があるとのことなので、権限状態を確認すると、以下の通りとなっております。

drwxr-xr-x  22 username  staff   704  7 21 15:41 .
drwxr-xr-x  28 username  staff   896  7 21 15:37 ..
drwxr-xr-x   7 username  staff   224  7 21 15:37 .git
-rw-r--r--   1 username  staff   766  7 21 15:37 .gitignore
-rw-r--r--   1 username  staff     6  7 21 15:37 .ruby-version
-rw-r--r--   1 username  staff  1965  7 21 15:37 Gemfile
-rw-r--r--   1 username  staff  5511  7 21 15:41 Gemfile.lock
-rw-r--r--   1 username  staff   374  7 21 15:37 README.md
-rw-r--r--   1 username  staff   227  7 21 15:37 Rakefile
drwxr-xr-x  11 username  staff   352  7 21 15:37 app
drwxr-xr-x   8 username  staff   256  7 21 15:41 bin
drwxr-xr-x  16 username  staff   512  7 21 15:37 config
-rw-r--r--   1 username  staff   130  7 21 15:37 config.ru
drwxr-xr-x   3 username  staff    96  7 21 15:37 db
drwxr-xr-x   4 username  staff   128  7 21 15:37 lib
drwxr-xr-x   4 username  staff   128  7 21 16:23 log
-rw-r--r--   1 username  staff   220  7 21 15:37 package.json
drwxr-xr-x   9 username  staff   288  7 21 15:37 public
drwxr-xr-x   3 username  staff    96  7 21 15:37 storage
drwxr-xr-x  12 username  staff   384  7 21 15:37 test
drwxr-xr-x   7 username  staff   224  7 21 16:23 tmp
drwxr-xr-x   3 username  staff    96  7 21 15:37 vendor


いろんな質問や記事を確認すると、usernameが”root”になっていることが多いから、それを自分のusernameに変えれば良いという回答だったので、権限を確認しましたが、全て私のユーザーネームになっています。

その為、この先の解決先が分からなく苦慮しております。

何卒、ご回答のほどよろしくお願い致します。

補足情報(FW/ツールのバージョンなど)

ProductName:    Mac OS X
ProductVersion:    10.14.6
Ruby 2.5.1
Rails 6.0.3.2

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 3

check解決した方法

0

結論から申し上げますと、解決致しました。

ls -ld /private /private/tmp


で/private/tmpの権限を確認してみると、下記のような結果になりました。

drwxr-xr-x   6 root    wheel   192  8 23  2019 /private
drwxr-xr-x  16 _mysql  _mysql  512  7 22 15:14 /private/tmp


本来ならば、_mysqlがrootになるはずですが、なぜか知りませんが、こうなっておりました。

そのため、下記を打ち込みました。

sudo chmod 1777 /private/tmp


そうすると、下記のように変更されました。

drwxr-xr-x   6 root  wheel  192  8 23  2019 /private
drwxrwxrwt  16 root  wheel  512  7 22 15:14 /private/tmp


この後に、質問内容に記載している手順でコマンドを打ち込んだ結果、正常に作動して、無事エラーも解消できました。

ご回答いただきありがとうございました!!

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

0

Macな人ではないのですが、
brew install yarn
はおそらく 個人エリアではなくシステム管理下にinstallするのではないでしょうか
とすると
sudo brew install yarn
してみてください

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2020/07/22 13:44

    ご回答ありがとうございます。

    ```
    sudo brew install yarn
    ```
    を実行すると、
    ```
    Error: Running Homebrew as root is extremely dangerous and no longer supported.
    As Homebrew does not drop privileges on installation you would be giving all
    build scripts full access to your system.
    ```
    となります。
    Homebrewはrootユーザーでの実行をサポートしていないようです。

    そのため、
    ```
    brew doctor
    ```
    でHomebrewの状態をチェックしてみました。

    そうすると、
    ```
    Your system is ready to brew.
    ```
    と表示され、特にエラーは無いようです。

    キャンセル

  • 2020/07/22 14:30

    違いましたか、、
    /private/tmp/homebrew20200722-28292-9dgqhj にPermission deniedなので、Rails.rootのpermissionではなく、/private/tmp 付近のものを調べてください。

    キャンセル

  • 2020/07/22 15:10

    ```
    ls -la /private/tmp/
    ```
    で確認してみますと、下記の表示結果になります。

    ```
    drwxr-xr-x 16 _mysql _mysql 512 7 22 14:14 .
    drwxr-xr-x 6 root wheel 192 8 23 2019 ..
    -rw-rw-r-- 1 root wheel 0 7 15 11:57 ICRC_ROLL.lck
    drwx------ 3 root wheel 96 7 15 12:18 PaxHeaders.378
    drwx------ 6 root wheel 192 7 22 14:14 com.apple.dyld
    drwx------ 3 username wheel 96 7 15 11:57 com.apple.launchd.GAJhuZexrs
    drwx------ 3 username wheel 96 7 15 11:57 com.apple.launchd.LlVFwpogbH
    drwxr-xr-x 4 root wheel 128 7 16 10:07 com.google.Keystone
    -rw-r--r-- 1 root _mysql 0 7 22 13:23 mysql.sock
    sr-xrwSrwt 1 root wheel 0 7 15 11:56 port.61100
    sr-xrwSrwt 1 root wheel 0 7 15 11:57 port.61201
    sr-xrwSrwt 1 root wheel 0 7 22 08:27 port.61301
    sr-xrwSrwt 1 root wheel 0 7 15 12:00 port.61303
    sr-xrwSrwt 1 root wheel 0 7 15 11:56 port.61304
    sr-xrwSrwt 1 root wheel 0 7 15 11:56 port.61401
    ```

    ここがrootになっているから、今回のエラーが発生しているということでしょうか??

    キャンセル

0

正しい解決法ではないかもしれないですが、
Rails 6.0.3.2から5.0.7.2にダウングレードさせました。
それにより、回答していたエラーは発生しなくなりました。

(別のサービスで5.0.7.2で作っていたものがあって、それは正常に動いておりましたので)

ご回答頂いたみなさま、ありがとうございました。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.91%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る